<?php

function fetchRequest($type = 'get')
{
    $renv = $type == 'get' ? getenv('QUERY_STRING') : getenv('POST');
    $request = array();
    if (!empty($renv)) {
        parse_str($renv, $request);
    }
    return $request;
}

function getView($view)
{
    global $appPath;
    $view_file = $appPath . "/views/" . $view . ".php";
    if (!is_file($view_file)) {
        return $appPath . "/views/404.php";
    }
    return $view_file;
}

function countrylist($search_flag = '')
{

    $countries = array(
        'AF' => 'Afghanistan',
        'AX' => 'Aland Islands',
        'AL' => 'Albania',
        'DZ' => 'Algeria',
        'AS' => 'American Samoa',
        'AD' => 'Andorra',
        'AO' => 'Angola',
        'AI' => 'Anguilla',
        'AQ' => 'Antarctica',
        'AG' => 'Antigua And Barbuda',
        'AR' => 'Argentina',
        'AM' => 'Armenia',
        'AW' => 'Aruba',
        'AU' => 'Australia',
        'AT' => 'Austria',
        'AZ' => 'Azerbaijan',
        'BS' => 'Bahamas',
        'BH' => 'Bahrain',
        'BD' => 'Bangladesh',
        'BB' => 'Barbados',
        'BY' => 'Belarus',
        'BE' => 'Belgium',
        'BZ' => 'Belize',
        'BJ' => 'Benin',
        'BM' => 'Bermuda',
        'BT' => 'Bhutan',
        'BO' => 'Bolivia',
        'BA' => 'Bosnia And Herzegovina',
        'BW' => 'Botswana',
        'BV' => 'Bouvet Island',
        'BR' => 'Brazil',
        'IO' => 'British Indian Ocean Territory',
        'BN' => 'Brunei Darussalam',
        'BG' => 'Bulgaria',
        'BF' => 'Burkina Faso',
        'BI' => 'Burundi',
        'KH' => 'Cambodia',
        'CM' => 'Cameroon',
        'CA' => 'Canada',
        'CV' => 'Cape Verde',
        'KY' => 'Cayman Islands',
        'CF' => 'Central African Republic',
        'TD' => 'Chad',
        'CL' => 'Chile',
        'CN' => 'China',
        'CX' => 'Christmas Island',
        'CC' => 'Cocos (Keeling) Islands',
        'CO' => 'Colombia',
        'KM' => 'Comoros',
        'CG' => 'Congo',
        'CD' => 'Congo, Democratic Republic',
        'CK' => 'Cook Islands',
        'CR' => 'Costa Rica',
        'CI' => 'Cote D\'Ivoire',
        'HR' => 'Croatia',
        'CU' => 'Cuba',
        'CY' => 'Cyprus',
        'CZ' => 'Czech Republic',
        'DK' => 'Denmark',
        'DJ' => 'Djibouti',
        'DM' => 'Dominica',
        'DO' => 'Dominican Republic',
        'EC' => 'Ecuador',
        'EG' => 'Egypt',
        'SV' => 'El Salvador',
        'GQ' => 'Equatorial Guinea',
        'ER' => 'Eritrea',
        'EE' => 'Estonia',
        'ET' => 'Ethiopia',
        'FK' => 'Falkland Islands (Malvinas)',
        'FO' => 'Faroe Islands',
        'FJ' => 'Fiji',
        'FI' => 'Finland',
        'FR' => 'France',
        'GF' => 'French Guiana',
        'PF' => 'French Polynesia',
        'TF' => 'French Southern Territories',
        'GA' => 'Gabon',
        'GM' => 'Gambia',
        'GE' => 'Georgia',
        'DE' => 'Germany',
        'GH' => 'Ghana',
        'GI' => 'Gibraltar',
        'GR' => 'Greece',
        'GL' => 'Greenland',
        'GD' => 'Grenada',
        'GP' => 'Guadeloupe',
        'GU' => 'Guam',
        'GT' => 'Guatemala',
        'GG' => 'Guernsey',
        'GN' => 'Guinea',
        'GW' => 'Guinea-Bissau',
        'GY' => 'Guyana',
        'HT' => 'Haiti',
        'HM' => 'Heard Island & Mcdonald Islands',
        'VA' => 'Holy See (Vatican City State)',
        'HN' => 'Honduras',
        'HK' => 'Hong Kong',
        'HU' => 'Hungary',
        'IS' => 'Iceland',
        'IN' => 'India',
        'ID' => 'Indonesia',
        'IR' => 'Iran, Islamic Republic Of',
        'IQ' => 'Iraq',
        'IE' => 'Ireland',
        'IM' => 'Isle Of Man',
        'IL' => 'Israel',
        'IT' => 'Italy',
        'JM' => 'Jamaica',
        'JP' => 'Japan',
        'JE' => 'Jersey',
        'JO' => 'Jordan',
        'KZ' => 'Kazakhstan',
        'KE' => 'Kenya',
        'KI' => 'Kiribati',
        'KR' => 'Korea',
        'KW' => 'Kuwait',
        'KG' => 'Kyrgyzstan',
        'LA' => 'Lao People\'s Democratic Republic',
        'LV' => 'Latvia',
        'LB' => 'Lebanon',
        'LS' => 'Lesotho',
        'LR' => 'Liberia',
        'LY' => 'Libyan Arab Jamahiriya',
        'LI' => 'Liechtenstein',
        'LT' => 'Lithuania',
        'LU' => 'Luxembourg',
        'MO' => 'Macao',
        'MK' => 'Macedonia',
        'MG' => 'Madagascar',
        'MW' => 'Malawi',
        'MY' => 'Malaysia',
        'MV' => 'Maldives',
        'ML' => 'Mali',
        'MT' => 'Malta',
        'MH' => 'Marshall Islands',
        'MQ' => 'Martinique',
        'MR' => 'Mauritania',
        'MU' => 'Mauritius',
        'YT' => 'Mayotte',
        'MX' => 'Mexico',
        'FM' => 'Micronesia, Federated States Of',
        'MD' => 'Moldova',
        'MC' => 'Monaco',
        'MN' => 'Mongolia',
        'ME' => 'Montenegro',
        'MS' => 'Montserrat',
        'MA' => 'Morocco',
        'MZ' => 'Mozambique',
        'MM' => 'Myanmar',
        'NA' => 'Namibia',
        'NR' => 'Nauru',
        'NP' => 'Nepal',
        'NL' => 'Netherlands',
        'AN' => 'Netherlands Antilles',
        'NC' => 'New Caledonia',
        'NZ' => 'New Zealand',
        'NI' => 'Nicaragua',
        'NE' => 'Niger',
        'NG' => 'Nigeria',
        'NU' => 'Niue',
        'NF' => 'Norfolk Island',
        'MP' => 'Northern Mariana Islands',
        'NO' => 'Norway',
        'OM' => 'Oman',
        'PK' => 'Pakistan',
        'PW' => 'Palau',
        'PS' => 'Palestinian Territory, Occupied',
        'PA' => 'Panama',
        'PG' => 'Papua New Guinea',
        'PY' => 'Paraguay',
        'PE' => 'Peru',
        'PH' => 'Philippines',
        'PN' => 'Pitcairn',
        'PL' => 'Poland',
        'PT' => 'Portugal',
        'PR' => 'Puerto Rico',
        'QA' => 'Qatar',
        'RE' => 'Reunion',
        'RO' => 'Romania',
        'RU' => 'Russian Federation',
        'RW' => 'Rwanda',
        'BL' => 'Saint Barthelemy',
        'SH' => 'Saint Helena',
        'KN' => 'Saint Kitts And Nevis',
        'LC' => 'Saint Lucia',
        'MF' => 'Saint Martin',
        'PM' => 'Saint Pierre And Miquelon',
        'VC' => 'Saint Vincent And Grenadines',
        'WS' => 'Samoa',
        'SM' => 'San Marino',
        'ST' => 'Sao Tome And Principe',
        'SA' => 'Saudi Arabia',
        'SN' => 'Senegal',
        'RS' => 'Serbia',
        'SC' => 'Seychelles',
        'SL' => 'Sierra Leone',
        'SG' => 'Singapore',
        'SK' => 'Slovakia',
        'SI' => 'Slovenia',
        'SB' => 'Solomon Islands',
        'SO' => 'Somalia',
        'ZA' => 'South Africa',
        'GS' => 'South Georgia And Sandwich Isl.',
        'ES' => 'Spain',
        'LK' => 'Sri Lanka',
        'SD' => 'Sudan',
        'SR' => 'Suriname',
        'SJ' => 'Svalbard And Jan Mayen',
        'SZ' => 'Swaziland',
        'SE' => 'Sweden',
        'CH' => 'Switzerland',
        'SY' => 'Syrian Arab Republic',
        'TW' => 'Taiwan',
        'TJ' => 'Tajikistan',
        'TZ' => 'Tanzania',
        'TH' => 'Thailand',
        'TL' => 'Timor-Leste',
        'TG' => 'Togo',
        'TK' => 'Tokelau',
        'TO' => 'Tonga',
        'TT' => 'Trinidad And Tobago',
        'TN' => 'Tunisia',
        'TR' => 'Turkey',
        'TM' => 'Turkmenistan',
        'TC' => 'Turks And Caicos Islands',
        'TV' => 'Tuvalu',
        'UG' => 'Uganda',
        'UA' => 'Ukraine',
        'AE' => 'United Arab Emirates',
        'GB' => 'United Kingdom',
        'US' => 'United States',
        'UM' => 'United States Outlying Islands',
        'UY' => 'Uruguay',
        'UZ' => 'Uzbekistan',
        'VU' => 'Vanuatu',
        'VE' => 'Venezuela',
        'VN' => 'Viet Nam',
        'VG' => 'Virgin Islands, British',
        'VI' => 'Virgin Islands, U.S.',
        'WF' => 'Wallis And Futuna',
        'EH' => 'Western Sahara',
        'YE' => 'Yemen',
        'ZM' => 'Zambia',
        'ZW' => 'Zimbabwe',
    );

    if (!empty($search_flag)) {
        return array_search($search_flag, $countries, true);
    } else {
        return $countries;
    }
}

function ip_is_private($ip)
{
    $pri_addrs = array(
        '10.0.0.0|10.255.255.255', // single class A network
        '172.16.0.0|172.31.255.255', // 16 contiguous class B network
        '192.168.0.0|192.168.255.255', // 256 contiguous class C network
        '169.254.0.0|169.254.255.255', // Link-local address also refered to as Automatic Private IP Addressing
        '127.0.0.0|127.255.255.255', // localhost
    );

    $long_ip = ip2long($ip);
    if ($long_ip != -1) {

        foreach ($pri_addrs as $pri_addr) {
            list($start, $end) = explode('|', $pri_addr);

            // IF IS PRIVATE
            if ($long_ip >= ip2long($start) && $long_ip <= ip2long($end)) {
                return true;
            }
        }
    }

    return false;
}

function flagSearch($searchIP)
{
    global $appPath;

    if (empty($searchIP)) {
        return;
    }
    $country_old = $appPath . '/db/country_ip_list.db';
    $db_country_old = new SQLite3($country_old);

    $country_new = $appPath . '/db/aast_ddos.db';
    $db_country_new = new SQLite3($country_new);

    $country_mapping = $appPath . '/db/updates.db';
    $db_country = new SQLite3($country_mapping);

    $ip_only = preg_replace('/\/\d+/', '', $searchIP);

    $ip_array = explode('.', $ip_only);

    $ip_array[3] = ($ip_array[3] == 0) ? 1 : $ip_array[3];

    $ip_check = implode('.', $ip_array);

    $ip_num = ip2long($ip_check);

    $result = $db_country_new->query("SELECT country_code FROM ip2location WHERE begin_ip < $ip_num AND end_ip > $ip_num");

    if (empty($result)) {
        $result = $db_country->query("SELECT country_code FROM ip2country WHERE ipaddress='$ip_only'");
    }

    if (empty($result)) {
        $result = $db_country_old->query("SELECT country_code FROM ip2c WHERE begin_ip_num < $ip_num AND end_ip_num > $ip_num");
    }

    $flag_id = '';
    if ($result) {
        while ($row = $result->fetchArray(SQLITE3_ASSOC)) {
            $flag_id_get = trim($row['country_code']);
            $flag_id = str_replace('\r', '', $flag_id_get);
            $flag_id = str_replace('\n', '', $flag_id_get);
        }
    }

    $flag_id = str_replace('\r', '', $flag_id);

    $countryList = countrylist();

    if (empty($flag_id) || trim($flag_id) == "-") {
        if (ip_is_private($ip_only)) {
            $flag_id = 'PrivateIP';
        } else {
            $flag_id = 'unknown';
        }
    } else {
        $country_name = $countryList[$flag_id];
        if (!$country_name) {
            $country_name = 'unknown';
        }
    }
    return [$flag_id, $country_name];
}

function ipBanHistory()
{
    global $db, $appPath;

    $perm_bann_ips = shell_exec($appPath . '/shell/functions getlist');
    $perm_bann_ips = trim($perm_bann_ips);
    $perm_bann_ips = explode(',', $perm_bann_ips);
    $perm_bann_ips_list = array();
    foreach ($perm_bann_ips as $values) {
        if (!empty($values)) {
            array_push($perm_bann_ips_list, strstr($values, ':', 1));
        }
    }

    $result = $db->query("SELECT ip,MAX(conn) conn,MAX(dt) dt,count(ip) total FROM bann GROUP BY ip");
    if ($result) {
        while ($row = $result->fetchArray(SQLITE3_ASSOC)) {
            $date = trim($row['dt']);
            $pos = strpos($row['ip'], ":");
            $pos1 = strpos($row['ip'], ".");
            if (($pos) || ($pos1)) {
                $ip = $row['ip'];

                $country_details = flagSearch($ip);
                $flag = $country_details[0];
                $countryName = $country_details[1];

                if (in_array($row['ip'], $perm_bann_ips_list)) {

                    $column5 = '<a style=" color: white; " class="btn btn-custom btn-sm"  href="/CMD_PLUGINS_ADMIN/ddos-deflate-interface/index.raw?act=unban&ip=' . $ip . '">Unban</a>
												';
                } else {
                    $column5 = '<a style=" color: white; " class="btn btn-custom btn-sm" href="/CMD_PLUGINS_ADMIN/ddos-deflate-interface/index.raw?act=ban-permanent&ip=' . $ip . '">Ban Permanently</a>';
                }
                if (!empty($row['ip'])) {
                    $data[] = array('ip' => $row['ip'], 'total-count' => $row['total'], 'connection-count' => $row['conn'], 'datestamp' => date('Y-m-d h:i:s', $date), 'button' => $column5, 'flag' => $flag, "country-name" => $countryName);
                }
            }
        }
    }
    return $data;
}

function unban($ip)
{
    global $appPath;
    if (filter_var($ip, FILTER_VALIDATE_IP)) {
        shell_exec($appPath . '/shell/functions unban ' . $ip);
        return true;
    } else {
        return false;
    }
}

function banPermanent($ip)
{
    global $appPath;
    if (filter_var($ip, FILTER_VALIDATE_IP)) {
        shell_exec($appPath . '/shell/functions ban ' . $ip . ' bannew');
        return true;
    } else {
        return false;
    }
}

function getBannedListRandom()
{
    global $appPath;
    $ips = shell_exec($appPath . '/shell/functions bann_list');
    $ips = explode(',', $ips);

    $ips = array_map('trim', $ips);

    $ips = array_filter($ips, 'strlen');

    $data = array();
    if (is_array($ips) && !empty($ips)) {
        foreach ($ips as $ip) {
            $ip_data = explode(':', $ip);
            $ipaddr = trim($ip_data[2]);

            $country_details = flagSearch($ipaddr);
            $flag = $country_details[0];
            $countryName = $country_details[1];
            if (!empty($ipaddr)) {
                $data[] = array(
                    'ip' => $ipaddr,
                    'flag' => $flag,
                    'country-name' => $countryName,
                );
            }
        }
    }

    return $data;
}

function banPermanentDelete($ip)
{
    global $appPath;
    if (filter_var($ip, FILTER_VALIDATE_IP)) {
        shell_exec($appPath . '/shell/functions removeban ' . $ip);
        return true;
    } else {
        return false;
    }
}

function banPermanentDb($ip)
{
    global $appPath;
    if (filter_var($ip, FILTER_VALIDATE_IP)) {
        shell_exec($appPath . '/shell/functions removeban ' . $ip);
        shell_exec($appPath . '/shell/functions bannew ' . $ip . ' bannew');
        return true;
    } else {
        return false;
    }
}

function getListRandom()
{
    global $appPath;
    $ips = shell_exec($appPath . '/shell/functions ipddos');
    $ips = explode(',', $ips);
    $ips = array_map('trim', $ips);
    $ips = array_filter($ips, 'strlen');
    $data = array();

    if (is_array($ips) && !empty($ips)) {
        foreach ($ips as $ip) {

            $ipaddr = explode(':', $ip);
            $country_details = flagSearch($ipaddr[0]);
            $flag = $country_details[0];
            $countryName = $country_details[1];

            if (!empty($ip)) {
                $data[] = array(
                    'ip' => $ip, 'button' => '<a class="btn btn-custom btn-sm" href="/CMD_PLUGINS_ADMIN/ddos-deflate-interface/index.raw?act=remove-ip&ip=' . $ip . '">Remove</a>', 'flag' => $flag, "country-name" => $countryName,
                );
            }
        }
    }
    return $data;
}

function removeIp($ip)
{
    global $appPath;
    $ip_data = trim($ip);
    $ip = explode(':', $ip_data);
    shell_exec($appPath . '/shell/functions deleteip ' . $ip[0] . ' ' . $ip[1]);
    if ($ip[1] == 0) {
        return 1;
    } else {
        return 2;
    }
}

function firewallRestart()
{
    global $appPath;
    shell_exec($appPath . '/shell/functions fwrestart');
}

function addIp($newIp, $newPort)
{
    global $appPath;
    if (!is_numeric($newPort)) {
        return array('status' => 'error', 'msg' => 'Port number is invalid (' . $newPort . ').');
    }
    if (file_exists($appPath . '/lists/ignore.ip.list')) {
        $file = file_get_contents($appPath . '/lists/ignore.ip.list');
    }
    // $file_ip = nl2br(htmlspecialchars($file));
    $file_array_1 = explode(PHP_EOL, $file);
    $file_array_2 = array_filter($file_array_1);
    $i = 0;

    if (file_exists($appPath . '/lists/ignore.cidr.list')) {
        $file1 = file_get_contents($appPath . '/lists/ignore.cidr.list');
    }
    $j = 0;
    // $file_ip_1 = nl2br(htmlspecialchars($file1));
    $file_array_3 = explode(PHP_EOL, $file1);
    $file_array_4 = array_filter($file_array_3);

    $IPadd = array_merge($file_array_2, $file_array_4);
    $IPadd = array_filter($IPadd);

    if (strpos($newIp, '/') !== true) {
        $ipTODB = explode('/', $newIp);
        $ipdb = $ipTODB[0];
    } else if (preg_match("/^(?:[-A-Za-z0-9]+\.)+[A-Za-z]{2,6}$/", $newIp)) {
        $ipdb_domain = $newIp;
    } else {
        $ipdb = $newIp;
    }

    $array_check = $newIp . ':' . $newPort;
    if (in_array($array_check, $IPadd, true)) {
        return array('status' => 'error', 'msg' => 'This IP is already in whitelist');
    } else {

        if (!empty($newIp)) {
            if (strpos($newIp, '/') !== false) {
                shell_exec($appPath . '/shell/functions addcidr ' . escapeshellarg($newIp) . ' ' . escapeshellarg($newPort));
            } else {

                if (filter_var($newIp, FILTER_VALIDATE_IP)) {
                    shell_exec($appPath . '/shell/functions addip ' . $newIp . ' ' . $newPort);
                } else {
                    $invalidIps[] = $newIp;
                }
            }

            if (!empty($invalidIps) && !empty($newIps)) {
                $invalidIps = implode(',', $invalidIps);
                return array('status' => 'error', 'msg' => 'The following IPs could not be added: ' . $invalidIps . '. Please check the format!');
            }
            return array('status' => 'success', 'msg' => 'IP ' . $newIp . ' with port ' . $newPort . ' has been added successfully!');
        }
    }
    shell_exec($appPath . '/shell/functions deletedb ' . $ipdb . ' ' . $newPort);
}

function countrymapAction($blocked)
{
    global $appPath;
    $c_list = '';
    $countryListFile = $appPath . '/lists/country_block.list';
    if (count($blocked) > 0) {
        $blocked = array_unique($blocked);
        $c_list = implode("\n", $blocked);
        file_put_contents($countryListFile, $c_list);
    } else {
        file_put_contents($countryListFile, $c_list);
    }
    return array('status' => 'success', 'msg' => 'Your settings have been saved!');
}

function countryBlockList()
{
    global $appPath;
    $countryListFile = $appPath . '/lists/country_block.list';
    if (file_exists($countryListFile)) {
        $file_data = file_get_contents($countryListFile);
    }
    $file_array_1 = explode(PHP_EOL, $file_data);
    $file_data_array = array_filter($file_array_1);
    return $file_data_array;
}

function defaultSettings()
{
    global $appPath;
    $defaults = shell_exec($appPath . '/shell/functions fileddos');
    $defaults = explode(',', $defaults);
    $defaults = array_map('trim', $defaults);
    $firewall_array = array();
    $firewall_array['0'] = 'IPTABLES';
    $firewall_array = shell_exec($appPath . '/shell/functions fwstatus');
    $firewall_array = explode(',', $firewall_array);
    $firewall_array = array_map('trim', $firewall_array);
    return array('defaults' => $defaults, 'firewall_list' => $firewall_array);
}

function saveSettings($frequency, $no_of_connection, $firewall, $time_to_block, $block_ip, $email_id, $pluginStatus, $history_size)
{
    global $appPath;
    $error = 0;
    $msginvalid = "";

    if (!is_numeric($frequency)) {
        $error = 1;
        $msginvalid = $msginvalid . "Invalid Frequency<br>";
    }
    if (!is_numeric($no_of_connection)) {
        $error = 1;
        $msginvalid = $msginvalid . " Invalid number of connections<br>";
    }
    if (!is_numeric($firewall)) {
        $error = 1;
        $msginvalid = $msginvalid . " Invalid firewall selected<br>";
    }
    if (!is_numeric($time_to_block)) {
        $error = 1;
        $msginvalid = $msginvalid . " Invalid IP ban time<br>";
    }
    if (!is_numeric($history_size)) {
        $error = 1;
        $msginvalid = $msginvalid . " Invalid history size<br>";
    }

    if (!empty($email_id) && (!filter_var($email_id, FILTER_VALIDATE_EMAIL))) {
        $error = 1;
        $msginvalid = $msginvalid . " Invalid Email format<br>";
    }

    if ($error == 0) {
        $response = shell_exec($appPath . '/shell/functions ddos modify ' . escapeshellarg($frequency) . ' ' . escapeshellarg($no_of_connection) . ' ' . escapeshellarg($firewall) . ' ' . escapeshellarg($time_to_block) . ' ' . escapeshellarg($email_id) . ' ' . escapeshellarg($block_ip) . ' ' . escapeshellarg($pluginStatus) . ' ' . escapeshellarg($history_size));
        $return['info'][] = 'Your settings have been saved!';
        $response = trim($response);

        if (!empty($response)) {
            $return['error'][] = $response;
        }
    } else {
        $return['error'][] = $msginvalid;
    }

    if (!empty($response)) {
        $response = trim($response);
        $return['error'][] = $response;
    }
    return $return;
}

function whmcs_license_verification($licensekey = "", $localkey = "")
{
    global $appPath;
    if (file_exists($appPath . "/license.conf")) {
        $localfile = file_get_contents($appPath . "/license.conf");
    }
    if (!empty($localfile) || (empty($licensekey))) {
        preg_match('/^license=(\S+)\n/', $localfile, $match);
        if (!isset($match[1])) {
            $match[1] = null;
        }
        $licensekey = $match[1];
        preg_match('/\nlocalkey=(\S+)\n/', $localfile, $match);
        if (!isset($match[1])) {
            $match[1] = null;
        }
        $localkey = $match[1];
    }

    $whmcsurl_https = trim(base64_decode("aHR0cHM6Ly9hZG1pbi1haGVhZC5jb20vcG9ydGFsLwo="));
    $whmcsurl = trim(base64_decode("aHR0cDovL2FkbWluLWFoZWFkLmNvbS9wb3J0YWwvCg=="));
    $licensing_secret_key = trim(base64_decode("YldFanMxdmNMeEtmSQo="));
    $check_token = time() . md5(mt_rand(1000000000, 9999999999) . $licensekey);
    $checkdate = date("Ymd");
    $usersip = '';
    $usersip = shell_exec($appPath . '/shell/functions getIP');
    $usersip = trim($usersip);
    $servername = shell_exec($appPath . '/shell/functions get-name');
    $servername = trim($servername);

    $localkeydays = 5;
    $allowcheckfaildays = 3;

    $localkeyvalid = false;
    if ($localkey) {
        $localkey = str_replace("\n", '', $localkey);
        $localdata = substr($localkey, 0, strlen($localkey) - 32);
        $md5hash = substr($localkey, strlen($localkey) - 32);
        if ($md5hash == md5($localdata . $licensing_secret_key)) {
            $localdata = strrev($localdata);
            $md5hash = substr($localdata, 0, 32);
            $localdata = substr($localdata, 32);
            $localdata = base64_decode($localdata);
            $localkeyresults = unserialize($localdata);
            $originalcheckdate = $localkeyresults["checkdate"];
            if ($md5hash == md5($originalcheckdate . $licensing_secret_key)) {
                $localexpiry = date("Ymd", mktime(0, 0, 0, date("m"), date("d") - $localkeydays, date("Y")));
                if ($originalcheckdate > $localexpiry) {
                    $localkeyvalid = true;
                    $result_data = $localkeyresults;
                    $validdomains = explode(",", $result_data["validdomain"]);
                    if (!in_array($servername, $validdomains)) {
                        $localkeyvalid = false;
                        $localkeyresults["status"] = "Inactive";
                        $result_data = array();
                    }
                    $validips = explode(",", $result_data["validip"]);
                    if (!in_array($usersip, $validips)) {
                        $localkeyvalid = false;
                        $localkeyresults["status"] = "Inactive";
                        $result_data = array();
                    }
                    if ($result_data["validdirectory"] != dirname(__FILE__)) {
                        $localkeyvalid = false;
                        $localkeyresults["status"] = "Inactive";
                        $result_data = array();
                    }
                }
            }
        }
    }
    if (!$localkeyvalid) {
        $postfields["licensekey"] = $licensekey;
        $postfields["domain"] = $servername;
        $postfields["ip"] = $usersip;
        $postfields["dir"] = dirname(__FILE__);
        if ($check_token) {
            $postfields["check_token"] = $check_token;
        }

        if (function_exists("curl_exec")) {
            $ch = curl_init();
            curl_setopt($ch, CURLOPT_URL, $whmcsurl_https . "modules/servers/licensing/verify.php");
            curl_setopt($ch, CURLOPT_POST, 1);
            curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
            curl_setopt($ch, CURLOPT_TIMEOUT, 30);
            curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
            curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 1);
            $data = curl_exec($ch);
            curl_close($ch);
            if (empty($data)) {
                $ch = curl_init();
                curl_setopt($ch, CURLOPT_URL, $whmcsurl . "modules/servers/licensing/verify.php");
                curl_setopt($ch, CURLOPT_POST, 1);
                curl_setopt($ch, CURLOPT_POSTFIELDS, $postfields);
                curl_setopt($ch, CURLOPT_TIMEOUT, 30);
                curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
                $data = curl_exec($ch);
                curl_close($ch);
            }
        } else {

            $fp = fsockopen($whmcsurl, 80, $errno, $errstr, 5);
            if ($fp) {
                $querystring = "";
                foreach ($postfields as $k => $v) {
                    $querystring .= "$k=" . urlencode($v) . "&";
                }
                $header = "POST " . $whmcsurl . "modules/servers/licensing/verify.php HTTP/1.0\r\n";
                $header .= "Host: " . $whmcsurl . "\r\n";
                $header .= "Content-type: application/x-www-form-urlencoded\r\n";
                $header .= "Content-length: " . @strlen($querystring) . "\r\n";
                $header .= "Connection: close\r\n\r\n";
                $header .= $querystring;
                $data = "";
                @stream_set_timeout($fp, 20);
                @fputs($fp, $header);
                $status = @socket_get_status($fp);
                while (!@feof($fp) && $status) {
                    $data .= @fgets($fp, 1024);
                    $status = @socket_get_status($fp);
                }
                @fclose($fp);
            }
        }
        if (!$data) {
            $localexpiry = date("Ymd", mktime(0, 0, 0, date("m"), date("d") - ($localkeydays + $allowcheckfaildays), date("Y")));
            if ($originalcheckdate > $localexpiry) {
                $result_data = $localkeyresults;
            } else {
                $result_data["status"] = "Inactive";
                $result_data["description"] = "Remote Check Failed";
                return $result_data;
            }
        } else {
            preg_match_all('/<(.*?)>([^<]+)<\/\\1>/i', $data, $matches);
            $result_data = array();
            foreach ($matches[1] as $k => $v) {
                $result_data[$v] = $matches[2][$k];
            }
        }
        if (isset($result_data["md5hash"])) {
            if ($result_data["md5hash"] != md5($licensing_secret_key . $check_token)) {
                $result_data["status"] = "Inactive";
                $result_data["description"] = "MD5 Checksum Verification Failed";
                return $result_data;
            }
        }
        if ($result_data["status"] == "Active") {
            $result_data["checkdate"] = $checkdate;
            $data_encoded = serialize($result_data);
            $data_encoded = base64_encode($data_encoded);
            $data_encoded = md5($checkdate . $licensing_secret_key) . $data_encoded;
            $data_encoded = strrev($data_encoded);
            $data_encoded = $data_encoded . md5($data_encoded . $licensing_secret_key);
            $data_encoded = wordwrap($data_encoded, 80, "\n", true);
            $result_data["localkey"] = $data_encoded;
        }
        $result_data["remotecheck"] = true;
    }
    unset($postfields, $data, $matches, $whmcsurl, $licensing_secret_key, $checkdate, $usersip, $localkeydays, $allowcheckfaildays, $md5hash);
    if ($result_data["status"] == "Active") {
        $license_filename = $appPath . "/license.conf";
        file_put_contents($license_filename, "license={$licensekey}\nlocalkey={$result_data['localkey']}");
        $appPath = '/usr/local/directadmin/plugins/ddos-deflate-interface/app';
        if (file_exists($appPath . "/initialize")) {
            $patterns = 'KILL="0"';
            $replacements = 'KILL="1"';
            $str = file_get_contents($appPath . "/ddos.conf");
            $str = str_replace($patterns, $replacements, $str);
            file_put_contents($appPath . "/ddos.conf", $str);
            unlink($appPath . "/initialize");
        }
    }
    return $result_data;
}

function cloudflareIps()
{
    $ipdat = explode("\n", file_get_contents(
        "https://www.cloudflare.com/ips-v4"
    ));
    return $ipdat;
}
