<?php
require 'inc/header.php';
?>
<div class="row">
    <div class="col-lg-12">
        <div class="card">
            <div class="card-header card-header-primary">
                <h4 class="card-title ">Whitelisted IPs</h4>
            </div>
            <div class="card-body">
                <div class="row">
                    <div class="col-lg-12">
                        <div class="table-responsive">
                            <table class="table table-striped" id="whitelist-table">
                                <thead class="text-th text-center">
                                    <tr>
                                        <th scope="col">S/N</th>
                                        <th scope="col">IP</th>
                                        <th scope="col">Country</th>
                                        <th scope="col">Actions</th>
                                    </tr>
                                </thead>
                                <tbody class="text-center">
                                    <?php
                                    $arr = defaultSettings();
                                    $defaults = $arr['defaults'];
                                    $cloudflareIps = cloudflareIps();
                                    $table = getListRandom();
                                    for ($i = 0; $i < sizeof($table); $i++) {
    $k = $i;
    ?>
                                        <tr>

                                            <td> <?php echo ++$k; ?> </td>
                                            <td> <?php
                                                    $show_ip = $table[$i]['ip'];
                                                    echo str_replace(':0', ':ALL', $show_ip);
                                                    echo "</td><td>";
                                                    if ($table[$i]['flag'] == 'PrivateIP') {
                                                        echo "<b>Private IP<b>";
                                                    } else if ($table[$i]['flag'] == 'unknown') {
                                                        echo "<img src='images/" . strtolower($table[$i]['flag']) . ".png' alt='" . $table[$i]['country-name'] . "' title='" . $table[$i]['country-name'] . "' style='width:48px;height:32px;'>";
                                                    } else {
                                                        echo "<img src='https://assets.ipstack.com/flags/" . strtolower($table[$i]['flag']) . ".svg' alt='" . $table[$i]['country-name'] . "' title='" . $table[$i]['country-name'] . "' style='width:48px;height:32px;'>";
                                                    }

                                                    ?> </td>
                                            <td> <?php
                                                    if (!in_array(str_replace(':0', '', $show_ip), $cloudflareIps)) {
                                                        echo $table[$i]['button'];
                                                    } else {
                                                        echo '<button class="btn btn-custom btn-sm" disabled>Cloudflare</a>';
                                                    }

                                                    ?> </td>


                                        </tr>
                                    <?php }?>
                                </tbody>
                            </table>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</div>

<!-- Modal -->
<div class="modal fade" id="exampleModal" tabindex="-1" aria-labelledby="exampleModalLabel" aria-hidden="true">
    <div class="modal-dialog">
        <div class="modal-content">
            <form action="/CMD_PLUGINS_ADMIN/ddos-deflate-interface/index.raw?act=add-ip" method="POST" id="add-ip" autocomplete="off">
                <div class="modal-header">
                    <h5 class="modal-title" id="exampleModalLabel">Add IP</h5>
                    <button type="button" class="btn-close" data-bs-dismiss="modal" aria-label="Close"></button>
                </div>
                <div class="modal-body">
                    <div class="row d-none" role="alert" id="error-div">
                        <div class="col alert alert-danger alert-dismissible fade show"></div>
                    </div>
                    <div class="row">
                        <div class="col-md-6">
                            <label for="ip" class="form-label">IP Address or CIDR Notation</label>
                            <input type="text" class="form-control" id="ip" name="ip" placeholder="192.168.1.1 & 192.160.0.0/24">
                        </div>
                        <div class="col-md-6">
                            <label for="port" class="form-label">Port</label>
                            <input type="text" class="form-control" id="port" name="port" placeholder="0 for all ports">
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button type="submit" class="btn btn-custom btn-sm">Add IP</button>
                </div>
            </form>
        </div>
    </div>
</div>

<form id="cloudflare-form" action="/CMD_PLUGINS_ADMIN/ddos-deflate-interface/index.raw?act=add-remove-cloudflare-ips" method="POST">
    <input type="hidden" name="enable-cloudflare" id="input-cloudflare" />
</form>
<script type="text/javascript">
    function GetURLParameter(sParam) {
        var sPageURL = window.location.search.substring(1);
        var sURLVariables = sPageURL.split('&');
        for (var i = 0; i < sURLVariables.length; i++) {
            var sParameterName = sURLVariables[i].split('=');
            if (sParameterName[0] == sParam) {
                return decodeURI(sParameterName[1]);
            }
        }
    }

    function validateIPaddress(ip) {
        if (/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)(\/([0-9]|[1-2][0-9]|3[0-2]))?$/.test(ip)) {
            return true;
        }
        return false;
    }

    function validatePort(port) {
        var reg = /^\d+$/;
        if (port >= 0 && port <= 65535 && reg.test(port)) {
            return true;
        }
        return false;
    }

    $(document).ready(function() {
        $("#add-ip").submit(function(event) {
            var error = "";
            if ($('#ip').val().length == 0) {
                error = "Please enter an IP<br>";
            } else if (!validateIPaddress($('#ip').val())) {
                error = "Please enter a valid IP<br>";
            }
            if ($('#port').val().length == 0) {
                error += "Please enter port number";
            } else if (!validatePort($('#port').val())) {
                error += "Please enter a valid port number";
            }
            if (error) {
                $("#error-div .col").html(error);
                $("#error-div").fadeTo(2000, 500).slideUp(500, function() {
                    $("#error-div").slideUp(500);
                });
                $("#error-div").removeClass('d-none');
                event.preventDefault();
            }

        });

        $('#whitelist-table').DataTable({
            language: {
                search: "",
                searchPlaceholder: "Search"
            },
            "dom": '<"toolbar"lf>rtip'
        });
        $("div.toolbar").append('<div class="float-end clearfix">' +
            '<input type="checkbox" class="btn-check" id="enable-cloudflare" autocomplete="off" <?php if ($defaults[7] === '1') {?> checked <?php }?>>' +
            '<label class="btn btn-outline-custom btn-sm me-2" for="enable-cloudflare" data-bs-toggle="tooltip" data-bs-placement="left" title="Will add IPs into whitelist">Secure Cloudflare IPs</label>' +
            '<button class="btn btn-custom btn-sm" data-bs-toggle="modal" data-bs-target="#exampleModal">Add IP</button>' +
            '</div>');

        if (window.location.hash == '#remove-ip-only') {
            history.pushState("", document.title, window.location.pathname +
                window.location.search);
            $('.toast-success .toast-body').html('IP has been removed!')
            $('.toast-success').toast('show');
        } else if (window.location.hash == '#remove-ip-n-port') {
            history.pushState("", document.title, window.location.pathname +
                window.location.search);
            $('.toast-success .toast-body').html('IP with port has been removed!')
            $('.toast-danger').toast('show');
        }

        if (window.location.hash == '#add-ip-success') {
            var msg = GetURLParameter('msg');
            history.pushState("", document.title, window.location.pathname +
                window.location.search);
            $('.toast-success .toast-body').html(msg)
            $('.toast-success').toast('show');
        } else if (window.location.hash == '#add-ip-error') {
            var msg = GetURLParameter('msg');
            history.pushState("", document.title, window.location.pathname +
                window.location.search);
            $('.toast-danger .toast-body').html(msg)
            $('.toast-danger').toast('show');
        }

        $("body").tooltip({
            selector: '[data-bs-toggle="tooltip"]'
        });

        $('body').on('change', '#enable-cloudflare', function(e) {
            if ($(this).prop("checked") == true) {
                $('#input-cloudflare').val(1);
            } else {
                $('#input-cloudflare').val(0);
            }
            $('#cloudflare-form').submit();
        })
    });
</script>
<?php
require 'inc/footer.php';
?>